---
product: "AG Grid"
title: "Cell Editing Validation"
description: "The Grid provides built-in validation for all , such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:"
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-start-stop/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-full-row/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Editing Validation

## Standard Validation

The Grid provides built-in validation for all [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/provided-cell-editors/), such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:

- `Text` and `Large Text` editors will respect the `maxLength` property.
- `Number` editors validate against min and max constraints.
- `Date` editors ensure the value is a valid date string.

Provided editors validate as their value changes and run a final validation when editing ends. The Grid handles invalid values based on the selected [Validation Modes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-validation/#validation-modes).

#### Cell Editor Validation

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  DateEditorModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  DateEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

interface IModifiedOlympicData extends IOlympicData {
  dateObj: Date | null;
}

let gridApi: GridApi<IModifiedOlympicData>;

const stringToDate = (date: string): Date | null => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return null;
  }
  return new Date(Number(year), Number(month) - 1, Number(day));
};

const dateToIso = (date: string | null): string => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return "";
  }
  return `${year}-${month}-${day}`;
};
const gridOptions: GridOptions<IModifiedOlympicData> = {
  columnDefs: [
    {
      field: "athlete",
      headerName: "Athlete (maxLength 10)",
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        maxLength: 10,
      },
    },
    {
      field: "age",
      headerName: "Age (>= 0 and <= 100)",
      cellEditor: "agNumberCellEditor",
      cellEditorParams: {
        min: 0,
        max: 100,
      },
    },
    {
      field: "dateObj",
      headerName: "Date (< 2009)",
      cellEditor: "agDateCellEditor",
      valueFormatter: (params: ValueFormatterParams<any, Date>) => {
        if (!params.value) {
          return "";
        }
        const month = params.value.getMonth() + 1;
        const day = params.value.getDate();
        return `${params.value.getFullYear()}-${month < 10 ? "0" + month : month}-${day < 10 ? "0" + day : day}`;
      },
      cellEditorParams: {
        max: new Date("2008-12-31"),
      },
    },
    {
      field: "date",
      headerName: "Date as String (> 2008)",
      cellEditor: "agDateStringCellEditor",
      cellEditorParams: {
        min: "2008-12-31",
      },
    },
  ],
  defaultColDef: {
    editable: true,
    cellDataType: false,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) =>
    gridApi!.setGridOption(
      "rowData",
      data.map((rec: IOlympicData) => ({
        ...rec,
        date: dateToIso(rec.date),
        dateObj: stringToDate(rec.date),
      })),
    ),
  );
```

[Live example: Cell Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation/typescript/)

## Overriding Validation

To customise validation in a Provided Editor, use the `getValidationErrors()` callback inside `ICellEditorParams`. The callback receives the editor's `internalErrors`, and its return value replaces the Provided Editor's validation result. Include `internalErrors` in the returned array if the built-in constraints should still apply alongside your custom rules.

Properties available on the `ICellEditorParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationErrors` | `Function` |  |  |  |

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'athlete',
            cellEditorParams: {
                getValidationErrors: (params) => {
                    const { value, internalErrors } = params;
                    const errors = [...(internalErrors ?? [])];
                    if (!value || value.length < 3) {
                        errors.push('The value has to be at least 3 characters long.');
                    }

                    return errors.length ? errors : null;
                },
            },
        },
    ],

    // other grid options ...
}
```

If the callback returns errors, the Grid will show the errors in a tooltip when hovering the editor and discard the edit value before completing (depending on the [Validation Modes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-validation/#validation-modes)).

This is demonstrated in the following example, note that:

- `Athlete` has to be at least `3` characters.
- `Age` has to be different than `18`.

#### Cell Editor Validation Override

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  IErrorValidationParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    {
      field: "athlete",
      cellEditorParams: {
        getValidationErrors: (params: IErrorValidationParams) => {
          const { value } = params;
          if (!value || value.length < 3) {
            return ["The value has to be at least 3 characters long."];
          }

          return null;
        },
      },
    },
    {
      field: "age",
      cellEditorParams: {
        getValidationErrors: (params: IErrorValidationParams) => {
          const { value } = params;

          if (value != null && value == 18) {
            return ["Value has to be different than 18"];
          }

          return null;
        },
      },
    },
  ],
  defaultColDef: {
    editable: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Cell Editor Validation Override](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-override/typescript/)

## Validation Modes

The Grid supports two modes for handling invalid edits, configured via the grid option `invalidEditValueMode`:

| Mode | Description |
| --- | --- |
| `'revert'` (default) | Cancels the edit and reverts the cell to its original value if the value is invalid. |
| `'block'` | Keeps the invalid editing session open until a valid value is provided or the edit is cancelled. Full Row Editing still allows navigation between editors in the same row. |

Use the `'block'` mode when you want to strictly enforce valid input before allowing the user to proceed.

```js
const gridOptions = {
    invalidEditValueMode: 'block',

    // other grid options ...
}
```

#### Cell Editor Validation Modes

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  EditValidationCommitType,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    {
      field: "athlete",
      headerName: "Athlete (maxLength 10)",
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        maxLength: 10,
      },
    },
    {
      field: "age",
      headerName: "Age (>= 0 and <=100)",
      cellEditor: "agNumberCellEditor",
      cellEditorParams: {
        min: 0,
        max: 100,
      },
    },
  ],
  defaultColDef: {
    editable: true,
  },

  invalidEditValueMode: "revert", // default value
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

function onValidationModeSelect() {
  const value: "revert" | "block" = document.querySelector<HTMLSelectElement>(
    "#select-validation-mode",
  )?.value as EditValidationCommitType;

  gridApi.setGridOption("invalidEditValueMode", value);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onValidationModeSelect = onValidationModeSelect;
}
```

[Live example: Cell Editor Validation Modes](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-modes/typescript/)

## Full Row Editing Validation

When using [Full Row Editing](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-full-row/), the Grid will validate each cell editor in the row individually, using the same mechanisms described in the previous sections.

In addition, the Grid can also perform cross-field validation by using the optional callback `getFullRowEditValidationErrors(params)`. This allows you to implement logic that checks relationships between fields — for example, ensuring that one field is greater than another.

This callback should return an array of non-empty, user-facing error strings if the row is in an invalid state. If no errors are found, it should return `null`.

The row data is not updated until the edit is committed. Use `editorsState` to validate the proposed row values; each entry contains the column ID together with its old and new values.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFullRowEditValidationErrors` | `GetFullRowEditValidationErrors` |  |  |  |

```js
const gridOptions = {
    getFullRowEditValidationErrors: ({ editorsState }) => {
        const values = Object.fromEntries(
            editorsState.map(({ colId, newValue }) => [colId, newValue]),
        );
        const min = Number(values.min);
        const max = Number(values.max);

        if (min > max) {
            return ['Min cannot be greater than Max'];
        }
        return null;
    },

    // other grid options ...
}
```

A row edit will only complete successfully if **both** the individual cell editors **and** the full-row validation return no errors.

### Accessibility

When a cell or full-row validation error is added, or its wording changes, the Grid announces the relevant error details to screen reader users. Revalidating unchanged errors, for example when navigating between editors in the same row, does not repeat the announcement.

If `invalidEditValueMode` is set to `'block'` and prevents the user from completing a full-row edit, the Grid announces a summary of the current errors even if they were announced previously. Cell editor errors are identified by their column name. Errors returned by `getFullRowEditValidationErrors` apply to the row as a whole, so each error message should identify the fields or condition that the user needs to correct.

The full-row announcement text can be customised through the `ariaFullRowValidationError` and `ariaFullRowEditValidationFailed` [localisation keys](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/localisation/). In a blocked-completion summary, `ariaRowIndex` identifies errors that belong to another edited row and distinguishes errors from multiple rows.

This is demonstrated in the following example. Note the following validation rules:

- `Weight` has to be between `0` and `500`, inclusive.
- `Height` has to be between `0` and `300`, inclusive.
- **Full Row Edit Validation** ensures that the Body Mass Index (BMI), calculated using height and weight, is between `10` and `80`.

#### Full Row Editing Validation

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  SelectEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SelectEditorModule,
  TextEditorModule,
  NumberEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    {
      field: "name",
    },
    {
      field: "weight",
      headerName: "Weight (kg)",
      cellDataType: "number",
      cellEditorParams: {
        min: 0,
        max: 500,
      },
    },
    {
      field: "height",
      headerName: "Height (cm)",
      cellDataType: "number",
      cellEditorParams: {
        min: 0,
        max: 300,
      },
    },
    {
      headerName: "BMI",
      cellDataType: "number",
      valueGetter: (params) => {
        const { weight, height } = params.data ?? {};
        if (!weight || !height) return null;
        const heightM = height / 100;
        return weight / (heightM * heightM);
      },
      valueFormatter: (params) => params.value?.toFixed(2),
      editable: false,
    },
  ],
  defaultColDef: {
    flex: 1,
    editable: true,
    cellDataType: false,
  },
  editType: "fullRow",
  rowData: getRowData(),
  invalidEditValueMode: "block",
  getFullRowEditValidationErrors: ({ editorsState }) => {
    const values = Object.fromEntries(
      editorsState.map(({ colId, newValue }) => [colId, newValue]),
    );

    const weight = parseFloat(values["weight"]);
    const height = parseFloat(values["height"]);

    const heightM = height / 100;
    const bmi = weight / (heightM * heightM);

    const errors: string[] = [];

    if (!Number.isFinite(bmi)) {
      errors.push(
        "BMI cannot be calculated. Enter valid Weight and Height values.",
      );
    } else if (bmi < 10 || bmi > 80) {
      errors.push(
        `BMI is ${bmi.toFixed(2)}. It must be between 10 and 80. Check Weight and Height.`,
      );
    }

    return errors.length ? errors : null;
  },
};

function getRowData() {
  const rowData = [
    { name: "Alice", weight: 68, height: 165 },
    { name: "Bob", weight: 85, height: 178 },
    { name: "Charlie", weight: 72, height: 172 },
    { name: "Diana", weight: 54, height: 160 },
    { name: "Ethan", weight: 90, height: 182 },
    { name: "Fiona", weight: 63, height: 168 },
    { name: "George", weight: 77, height: 175 },
    { name: "Hannah", weight: 59, height: 162 },
    { name: "Ian", weight: 95, height: 185 },
    { name: "Julia", weight: 70, height: 170 },
  ];

  return rowData;
}

// wait for the document to be loaded, otherwise
// AG Grid will not find the div in the document.
const eGridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(eGridDiv, gridOptions);
```

[Live example: Full Row Editing Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/full-row-editing-validation/typescript/)

## Validation of Custom Editors

Custom Cell Editors can participate in the Grid's validation system by optionally implementing the following methods:

Properties available on the `ICellEditor&lt;TValue = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationElement` | `Function` |  |  |  |
| `getValidationErrors` | `Function` |  |  |  |

These methods are called automatically before the Grid attempts to complete the edit. You can also manually trigger validation by calling the validate() method available in the cellEditorParams, for example:

```
cellEditorParams.validate();
```

This is useful if you want to validate input during editing, such as in response to an onInput event in the Custom Phone Editor.

#### Component Editor Validation

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  CustomEditorModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RichSelectModule } from "ag-grid-enterprise";
import { getData } from "./data";
import { PhoneEditor } from "./phoneEditor";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RichSelectModule,
  NumberEditorModule,
  TextEditorModule,
  CustomEditorModule,
]);

const columnDefs: ColDef[] = [
  { field: "name" },
  {
    field: "phone",
    headerName: "Custom Phone Editor",
    cellEditor: PhoneEditor,
  },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  rowData: getData(),
  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Component Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/component-editor-validation/typescript/)


---
product: "AG Grid"
title: "Cell Editing Validation"
description: "The Grid provides built-in validation for all , such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:"
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-start-stop/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-full-row/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Editing Validation

## Standard Validation

The Grid provides built-in validation for all [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/react-data-grid/provided-cell-editors/), such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:

- `Text` and `Large Text` editors will respect the `maxLength` property.
- `Number` editors validate against min and max constraints.
- `Date` editors ensure the value is a valid date string.

Provided editors validate as their value changes and run a final validation when editing ends. The Grid handles invalid values based on the selected [Validation Modes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-validation/#validation-modes).

#### Cell Editor Validation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  DateEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
];

interface IModifiedOlympicData extends IOlympicData {
  dateObj: Date | null;
}

const stringToDate = (date: string): Date | null => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return null;
  }
  return new Date(Number(year), Number(month) - 1, Number(day));
};

const dateToIso = (date: string | null): string => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return "";
  }
  return `${year}-${month}-${day}`;
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IModifiedOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      headerName: "Athlete (maxLength 10)",
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        maxLength: 10,
      },
    },
    {
      field: "age",
      headerName: "Age (>= 0 and <= 100)",
      cellEditor: "agNumberCellEditor",
      cellEditorParams: {
        min: 0,
        max: 100,
      },
    },
    {
      field: "dateObj",
      headerName: "Date (< 2009)",
      cellEditor: "agDateCellEditor",
      valueFormatter: (params: ValueFormatterParams<any, Date>) => {
        if (!params.value) {
          return "";
        }
        const month = params.value.getMonth() + 1;
        const day = params.value.getDate();
        return `${params.value.getFullYear()}-${month < 10 ? "0" + month : month}-${day < 10 ? "0" + day : day}`;
      },
      cellEditorParams: {
        max: new Date("2008-12-31"),
      },
    },
    {
      field: "date",
      headerName: "Date as String (> 2008)",
      cellEditor: "agDateStringCellEditor",
      cellEditorParams: {
        min: "2008-12-31",
      },
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      cellDataType: false,
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IModifiedOlympicData[]) =>
        setRowData(
          data.map((rec: IOlympicData) => ({
            ...rec,
            date: dateToIso(rec.date),
            dateObj: stringToDate(rec.date),
          })),
        ),
      );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IModifiedOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            onGridReady={onGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation/reactFunctionalTs/)

## Overriding Validation

To customise validation in a Provided Editor, use the `getValidationErrors()` callback inside `ICellEditorParams`. The callback receives the editor's `internalErrors`, and its return value replaces the Provided Editor's validation result. Include `internalErrors` in the returned array if the built-in constraints should still apply alongside your custom rules.

Properties available on the `ICellEditorParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationErrors` | `Function` |  |  |  |

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'athlete',
        cellEditorParams: {
            getValidationErrors: (params) => {
                const { value, internalErrors } = params;
                const errors = [...(internalErrors ?? [])];
                if (!value || value.length < 3) {
                    errors.push('The value has to be at least 3 characters long.');
                }

                return errors.length ? errors : null;
            },
        },
    },
]);

<AgGridReact columnDefs={columnDefs} />
```

If the callback returns errors, the Grid will show the errors in a tooltip when hovering the editor and discard the edit value before completing (depending on the [Validation Modes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-validation/#validation-modes)).

This is demonstrated in the following example, note that:

- `Athlete` has to be at least `3` characters.
- `Age` has to be different than `18`.

#### Cell Editor Validation Override

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  IErrorValidationParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      cellEditorParams: {
        getValidationErrors: (params: IErrorValidationParams) => {
          const { value } = params;
          if (!value || value.length < 3) {
            return ["The value has to be at least 3 characters long."];
          }
          return null;
        },
      },
    },
    {
      field: "age",
      cellEditorParams: {
        getValidationErrors: (params: IErrorValidationParams) => {
          const { value } = params;
          if (value != null && value == 18) {
            return ["Value has to be different than 18"];
          }
          return null;
        },
      },
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Editor Validation Override](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-override/reactFunctionalTs/)

## Validation Modes

The Grid supports two modes for handling invalid edits, configured via the grid option `invalidEditValueMode`:

| Mode | Description |
| --- | --- |
| `'revert'` (default) | Cancels the edit and reverts the cell to its original value if the value is invalid. |
| `'block'` | Keeps the invalid editing session open until a valid value is provided or the edit is cancelled. Full Row Editing still allows navigation between editors in the same row. |

Use the `'block'` mode when you want to strictly enforce valid input before allowing the user to proceed.

```jsx
const invalidEditValueMode = 'block';

<AgGridReact invalidEditValueMode={invalidEditValueMode} />
```

#### Cell Editor Validation Modes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  EditValidationCommitType,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      headerName: "Athlete (maxLength 10)",
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        maxLength: 10,
      },
    },
    {
      field: "age",
      headerName: "Age (>= 0 and <=100)",
      cellEditor: "agNumberCellEditor",
      cellEditorParams: {
        min: 0,
        max: 100,
      },
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onValidationModeSelect = useCallback(() => {
    const value: "revert" | "block" = document.querySelector<HTMLSelectElement>(
      "#select-validation-mode",
    )?.value as EditValidationCommitType;
    gridRef.current!.api.setGridOption("invalidEditValueMode", value);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <label>
              <span>Cell Editor Validation Mode: </span>
              <select
                id="select-validation-mode"
                onChange={onValidationModeSelect}
              >
                <option value="revert">revert</option>
                <option value="block">block</option>
              </select>
            </label>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              invalidEditValueMode={"revert"}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Editor Validation Modes](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-modes/reactFunctionalTs/)

## Full Row Editing Validation

When using [Full Row Editing](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-full-row/), the Grid will validate each cell editor in the row individually, using the same mechanisms described in the previous sections.

In addition, the Grid can also perform cross-field validation by using the optional callback `getFullRowEditValidationErrors(params)`. This allows you to implement logic that checks relationships between fields — for example, ensuring that one field is greater than another.

This callback should return an array of non-empty, user-facing error strings if the row is in an invalid state. If no errors are found, it should return `null`.

The row data is not updated until the edit is committed. Use `editorsState` to validate the proposed row values; each entry contains the column ID together with its old and new values.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFullRowEditValidationErrors` | `GetFullRowEditValidationErrors` |  |  |  |

```jsx
const getFullRowEditValidationErrors = ({ editorsState }) => {
    const values = Object.fromEntries(
        editorsState.map(({ colId, newValue }) => [colId, newValue]),
    );
    const min = Number(values.min);
    const max = Number(values.max);

    if (min > max) {
        return ['Min cannot be greater than Max'];
    }
    return null;
};

<AgGridReact getFullRowEditValidationErrors={getFullRowEditValidationErrors} />
```

A row edit will only complete successfully if **both** the individual cell editors **and** the full-row validation return no errors.

### Accessibility

When a cell or full-row validation error is added, or its wording changes, the Grid announces the relevant error details to screen reader users. Revalidating unchanged errors, for example when navigating between editors in the same row, does not repeat the announcement.

If `invalidEditValueMode` is set to `'block'` and prevents the user from completing a full-row edit, the Grid announces a summary of the current errors even if they were announced previously. Cell editor errors are identified by their column name. Errors returned by `getFullRowEditValidationErrors` apply to the row as a whole, so each error message should identify the fields or condition that the user needs to correct.

The full-row announcement text can be customised through the `ariaFullRowValidationError` and `ariaFullRowEditValidationFailed` [localisation keys](https://www.ag-grid.com/archive/36.2.0/react-data-grid/localisation/). In a blocked-completion summary, `ariaRowIndex` identifies errors that belong to another edited row and distinguishes errors from multiple rows.

This is demonstrated in the following example. Note the following validation rules:

- `Weight` has to be between `0` and `500`, inclusive.
- `Height` has to be between `0` and `300`, inclusive.
- **Full Row Edit Validation** ensures that the Body Mass Index (BMI), calculated using height and weight, is between `10` and `80`.

#### Full Row Editing Validation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  EditStrategyType,
  EditValidationCommitType,
  GetFullRowEditValidationErrors,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  SelectEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SelectEditorModule,
  TextEditorModule,
  NumberEditorModule,
];

function getRowData() {
  const rowData = [
    { name: "Alice", weight: 68, height: 165 },
    { name: "Bob", weight: 85, height: 178 },
    { name: "Charlie", weight: 72, height: 172 },
    { name: "Diana", weight: 54, height: 160 },
    { name: "Ethan", weight: 90, height: 182 },
    { name: "Fiona", weight: 63, height: 168 },
    { name: "George", weight: 77, height: 175 },
    { name: "Hannah", weight: 59, height: 162 },
    { name: "Ian", weight: 95, height: 185 },
    { name: "Julia", weight: 70, height: 170 },
  ];
  return rowData;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "name",
    },
    {
      field: "weight",
      headerName: "Weight (kg)",
      cellDataType: "number",
      cellEditorParams: {
        min: 0,
        max: 500,
      },
    },
    {
      field: "height",
      headerName: "Height (cm)",
      cellDataType: "number",
      cellEditorParams: {
        min: 0,
        max: 300,
      },
    },
    {
      headerName: "BMI",
      cellDataType: "number",
      valueGetter: (params) => {
        const { weight, height } = params.data ?? {};
        if (!weight || !height) return null;
        const heightM = height / 100;
        return weight / (heightM * heightM);
      },
      valueFormatter: (params) => params.value?.toFixed(2),
      editable: false,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      editable: true,
      cellDataType: false,
    };
  }, []);
  const getFullRowEditValidationErrors = useCallback(({ editorsState }) => {
    const values = Object.fromEntries(
      editorsState.map(({ colId, newValue }) => [colId, newValue]),
    );
    const weight = parseFloat(values["weight"]);
    const height = parseFloat(values["height"]);
    const heightM = height / 100;
    const bmi = weight / (heightM * heightM);
    const errors: string[] = [];
    if (!Number.isFinite(bmi)) {
      errors.push(
        "BMI cannot be calculated. Enter valid Weight and Height values.",
      );
    } else if (bmi < 10 || bmi > 80) {
      errors.push(
        `BMI is ${bmi.toFixed(2)}. It must be between 10 and 80. Check Weight and Height.`,
      );
    }
    return errors.length ? errors : null;
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            editType={"fullRow"}
            invalidEditValueMode={"block"}
            getFullRowEditValidationErrors={getFullRowEditValidationErrors}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Full Row Editing Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/full-row-editing-validation/reactFunctionalTs/)

## Validation of Custom Editors

Custom Cell Editors can participate in the Grid's validation system by optionally implementing the following methods:

Properties available on the `ICellEditor&lt;TValue = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationElement` | `Function` |  |  |  |
| `getValidationErrors` | `Function` |  |  |  |

These methods are called automatically before the Grid attempts to complete the edit. You can also manually trigger validation by calling the validate() method available in the cellEditorParams, for example:

```
cellEditorParams.validate();
```

This is useful if you want to validate input during editing, such as in response to an onInput event in the Custom Phone Editor.

#### Component Editor Validation

```tsx
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  CustomEditorModule,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RichSelectModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import { getData } from "./data";
import PhoneEditor from "./phoneEditor";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  CustomEditorModule,
  ClientSideRowModelModule,
  RichSelectModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "name" },
    {
      field: "phone",
      headerName: "Custom Phone Editor",
      cellEditor: PhoneEditor,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Component Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/component-editor-validation/reactFunctionalTs/)


---
product: "AG Grid"
title: "Cell Editing Validation"
description: "The Grid provides built-in validation for all , such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:"
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-start-stop/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-full-row/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Editing Validation

## Standard Validation

The Grid provides built-in validation for all [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/provided-cell-editors/), such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:

- `Text` and `Large Text` editors will respect the `maxLength` property.
- `Number` editors validate against min and max constraints.
- `Date` editors ensure the value is a valid date string.

Provided editors validate as their value changes and run a final validation when editing ends. The Grid handles invalid values based on the selected [Validation Modes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-validation/#validation-modes).

#### Cell Editor Validation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  DateEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

interface IModifiedOlympicData extends IOlympicData {
  dateObj: Date | null;
}

const stringToDate = (date: string): Date | null => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return null;
  }
  return new Date(Number(year), Number(month) - 1, Number(day));
};

const dateToIso = (date: string | null): string => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return "";
  }
  return `${year}-${month}-${day}`;
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      v-model="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IModifiedOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        headerName: "Athlete (maxLength 10)",
        cellEditor: "agTextCellEditor",
        cellEditorParams: {
          maxLength: 10,
        },
      },
      {
        field: "age",
        headerName: "Age (>= 0 and <= 100)",
        cellEditor: "agNumberCellEditor",
        cellEditorParams: {
          min: 0,
          max: 100,
        },
      },
      {
        field: "dateObj",
        headerName: "Date (< 2009)",
        cellEditor: "agDateCellEditor",
        valueFormatter: (params: ValueFormatterParams<any, Date>) => {
          if (!params.value) {
            return "";
          }
          const month = params.value.getMonth() + 1;
          const day = params.value.getDate();
          return `${params.value.getFullYear()}-${month < 10 ? "0" + month : month}-${day < 10 ? "0" + day : day}`;
        },
        cellEditorParams: {
          max: new Date("2008-12-31"),
        },
      },
      {
        field: "date",
        headerName: "Date as String (> 2008)",
        cellEditor: "agDateStringCellEditor",
        cellEditorParams: {
          min: "2008-12-31",
        },
      },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      cellDataType: false,
    });
    const rowData = ref<IModifiedOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) =>
        (rowData.value = data.map((rec: IOlympicData) => ({
          ...rec,
          date: dateToIso(rec.date),
          dateObj: stringToDate(rec.date),
        })));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation/vue3/)

## Overriding Validation

To customise validation in a Provided Editor, use the `getValidationErrors()` callback inside `ICellEditorParams`. The callback receives the editor's `internalErrors`, and its return value replaces the Provided Editor's validation result. Include `internalErrors` in the returned array if the built-in constraints should still apply alongside your custom rules.

Properties available on the `ICellEditorParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationErrors` | `Function` |  |  |  |

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'athlete',
        cellEditorParams: {
            getValidationErrors: (params) => {
                const { value, internalErrors } = params;
                const errors = [...(internalErrors ?? [])];
                if (!value || value.length < 3) {
                    errors.push('The value has to be at least 3 characters long.');
                }

                return errors.length ? errors : null;
            },
        },
    },
];
```

If the callback returns errors, the Grid will show the errors in a tooltip when hovering the editor and discard the edit value before completing (depending on the [Validation Modes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-validation/#validation-modes)).

This is demonstrated in the following example, note that:

- `Athlete` has to be at least `3` characters.
- `Age` has to be different than `18`.

#### Cell Editor Validation Override

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  IErrorValidationParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      v-model="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        cellEditorParams: {
          getValidationErrors: (params: IErrorValidationParams) => {
            const { value } = params;
            if (!value || value.length < 3) {
              return ["The value has to be at least 3 characters long."];
            }
            return null;
          },
        },
      },
      {
        field: "age",
        cellEditorParams: {
          getValidationErrors: (params: IErrorValidationParams) => {
            const { value } = params;
            if (value != null && value == 18) {
              return ["Value has to be different than 18"];
            }
            return null;
          },
        },
      },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Editor Validation Override](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-override/vue3/)

## Validation Modes

The Grid supports two modes for handling invalid edits, configured via the grid option `invalidEditValueMode`:

| Mode | Description |
| --- | --- |
| `'revert'` (default) | Cancels the edit and reverts the cell to its original value if the value is invalid. |
| `'block'` | Keeps the invalid editing session open until a valid value is provided or the edit is cancelled. Full Row Editing still allows navigation between editors in the same row. |

Use the `'block'` mode when you want to strictly enforce valid input before allowing the user to proceed.

```ts
<ag-grid-vue
    :invalidEditValueMode="invalidEditValueMode"
    /* other grid options ... */>
</ag-grid-vue>

this.invalidEditValueMode = 'block';
```

#### Cell Editor Validation Modes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  EditValidationCommitType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <label>
          <span>Cell Editor Validation Mode: </span>
          <select id="select-validation-mode" v-on:change="onValidationModeSelect()">
            <option value="revert">revert</option>
            <option value="block">block</option>
          </select>
        </label>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :invalidEditValueMode="invalidEditValueMode"
        v-model="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        headerName: "Athlete (maxLength 10)",
        cellEditor: "agTextCellEditor",
        cellEditorParams: {
          maxLength: 10,
        },
      },
      {
        field: "age",
        headerName: "Age (>= 0 and <=100)",
        cellEditor: "agNumberCellEditor",
        cellEditorParams: {
          min: 0,
          max: 100,
        },
      },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
    });
    const invalidEditValueMode = ref<EditValidationCommitType>("revert");
    const rowData = ref<IOlympicData[]>(null);

    function onValidationModeSelect() {
      const value: "revert" | "block" =
        document.querySelector<HTMLSelectElement>("#select-validation-mode")
          ?.value as EditValidationCommitType;
      gridApi.value.setGridOption("invalidEditValueMode", value);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      invalidEditValueMode,
      rowData,
      onGridReady,
      onValidationModeSelect,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Editor Validation Modes](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-modes/vue3/)

## Full Row Editing Validation

When using [Full Row Editing](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-full-row/), the Grid will validate each cell editor in the row individually, using the same mechanisms described in the previous sections.

In addition, the Grid can also perform cross-field validation by using the optional callback `getFullRowEditValidationErrors(params)`. This allows you to implement logic that checks relationships between fields — for example, ensuring that one field is greater than another.

This callback should return an array of non-empty, user-facing error strings if the row is in an invalid state. If no errors are found, it should return `null`.

The row data is not updated until the edit is committed. Use `editorsState` to validate the proposed row values; each entry contains the column ID together with its old and new values.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFullRowEditValidationErrors` | `GetFullRowEditValidationErrors` |  |  |  |

```ts
<ag-grid-vue
    :getFullRowEditValidationErrors="getFullRowEditValidationErrors"
    /* other grid options ... */>
</ag-grid-vue>

this.getFullRowEditValidationErrors = ({ editorsState }) => {
    const values = Object.fromEntries(
        editorsState.map(({ colId, newValue }) => [colId, newValue]),
    );
    const min = Number(values.min);
    const max = Number(values.max);

    if (min > max) {
        return ['Min cannot be greater than Max'];
    }
    return null;
};
```

A row edit will only complete successfully if **both** the individual cell editors **and** the full-row validation return no errors.

### Accessibility

When a cell or full-row validation error is added, or its wording changes, the Grid announces the relevant error details to screen reader users. Revalidating unchanged errors, for example when navigating between editors in the same row, does not repeat the announcement.

If `invalidEditValueMode` is set to `'block'` and prevents the user from completing a full-row edit, the Grid announces a summary of the current errors even if they were announced previously. Cell editor errors are identified by their column name. Errors returned by `getFullRowEditValidationErrors` apply to the row as a whole, so each error message should identify the fields or condition that the user needs to correct.

The full-row announcement text can be customised through the `ariaFullRowValidationError` and `ariaFullRowEditValidationFailed` [localisation keys](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/localisation/). In a blocked-completion summary, `ariaRowIndex` identifies errors that belong to another edited row and distinguishes errors from multiple rows.

This is demonstrated in the following example. Note the following validation rules:

- `Weight` has to be between `0` and `500`, inclusive.
- `Height` has to be between `0` and `300`, inclusive.
- **Full Row Edit Validation** ensures that the Body Mass Index (BMI), calculated using height and weight, is between `10` and `80`.

#### Full Row Editing Validation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  EditStrategyType,
  EditValidationCommitType,
  GetFullRowEditValidationErrors,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  SelectEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SelectEditorModule,
  TextEditorModule,
  NumberEditorModule,
]);

function getRowData() {
  const rowData = [
    { name: "Alice", weight: 68, height: 165 },
    { name: "Bob", weight: 85, height: 178 },
    { name: "Charlie", weight: 72, height: 172 },
    { name: "Diana", weight: 54, height: 160 },
    { name: "Ethan", weight: 90, height: 182 },
    { name: "Fiona", weight: 63, height: 168 },
    { name: "George", weight: 77, height: 175 },
    { name: "Hannah", weight: 59, height: 162 },
    { name: "Ian", weight: 95, height: 185 },
    { name: "Julia", weight: 70, height: 170 },
  ];
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :editType="editType"
      :rowData="rowData"
      :invalidEditValueMode="invalidEditValueMode"
      :getFullRowEditValidationErrors="getFullRowEditValidationErrors"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "name",
      },
      {
        field: "weight",
        headerName: "Weight (kg)",
        cellDataType: "number",
        cellEditorParams: {
          min: 0,
          max: 500,
        },
      },
      {
        field: "height",
        headerName: "Height (cm)",
        cellDataType: "number",
        cellEditorParams: {
          min: 0,
          max: 300,
        },
      },
      {
        headerName: "BMI",
        cellDataType: "number",
        valueGetter: (params) => {
          const { weight, height } = params.data ?? {};
          if (!weight || !height) return null;
          const heightM = height / 100;
          return weight / (heightM * heightM);
        },
        valueFormatter: (params) => params.value?.toFixed(2),
        editable: false,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      editable: true,
      cellDataType: false,
    });
    const editType = ref<EditStrategyType>("fullRow");
    const rowData = ref<any[] | null>(getRowData());
    const invalidEditValueMode = ref<EditValidationCommitType>("block");
    const getFullRowEditValidationErrors = ref<GetFullRowEditValidationErrors>(
      ({ editorsState }) => {
        const values = Object.fromEntries(
          editorsState.map(({ colId, newValue }) => [colId, newValue]),
        );
        const weight = parseFloat(values["weight"]);
        const height = parseFloat(values["height"]);
        const heightM = height / 100;
        const bmi = weight / (heightM * heightM);
        const errors: string[] = [];
        if (!Number.isFinite(bmi)) {
          errors.push(
            "BMI cannot be calculated. Enter valid Weight and Height values.",
          );
        } else if (bmi < 10 || bmi > 80) {
          errors.push(
            `BMI is ${bmi.toFixed(2)}. It must be between 10 and 80. Check Weight and Height.`,
          );
        }
        return errors.length ? errors : null;
      },
    );

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      editType,
      rowData,
      invalidEditValueMode,
      getFullRowEditValidationErrors,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Full Row Editing Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/full-row-editing-validation/vue3/)

## Validation of Custom Editors

Custom Cell Editors can participate in the Grid's validation system by optionally implementing the following methods:

Properties available on the `ICellEditor&lt;TValue = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationElement` | `Function` |  |  |  |
| `getValidationErrors` | `Function` |  |  |  |

These methods are called automatically before the Grid attempts to complete the edit. You can also manually trigger validation by calling the validate() method available in the cellEditorParams, for example:

```
cellEditorParams.validate();
```

This is useful if you want to validate input during editing, such as in response to an onInput event in the Custom Phone Editor.

#### Component Editor Validation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RichSelectModule } from "ag-grid-enterprise";
import PhoneEditor from "./phoneEditorVue";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RichSelectModule,
  NumberEditorModule,
  TextEditorModule,
  CustomEditorModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :rowData="rowData"
      :defaultColDef="defaultColDef"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    PhoneEditor,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "name" },
      {
        field: "phone",
        headerName: "Custom Phone Editor",
        cellEditor: "PhoneEditor",
      },
    ]);
    const rowData = ref<any[] | null>(getData());
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      defaultColDef,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Component Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/component-editor-validation/vue3/)


---
product: "AG Grid"
title: "Cell Editing Validation"
description: "The Grid provides built-in validation for all , such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:"
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-start-stop/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-full-row/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Editing Validation

## Standard Validation

The Grid provides built-in validation for all [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/provided-cell-editors/), such as the Text, Large Text, Number and Date editors. These editors support validation automatically by checking the constraints defined in the column configuration. For example:

- `Text` and `Large Text` editors will respect the `maxLength` property.
- `Number` editors validate against min and max constraints.
- `Date` editors ensure the value is a valid date string.

Provided editors validate as their value changes and run a final validation when editing ends. The Grid handles invalid values based on the selected [Validation Modes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-validation/#validation-modes).

#### Cell Editor Validation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  DateEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);

interface IModifiedOlympicData extends IOlympicData {
  dateObj: Date | null;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      headerName: "Athlete (maxLength 10)",
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        maxLength: 10,
      },
    },
    {
      field: "age",
      headerName: "Age (>= 0 and <= 100)",
      cellEditor: "agNumberCellEditor",
      cellEditorParams: {
        min: 0,
        max: 100,
      },
    },
    {
      field: "dateObj",
      headerName: "Date (< 2009)",
      cellEditor: "agDateCellEditor",
      valueFormatter: (params: ValueFormatterParams<any, Date>) => {
        if (!params.value) {
          return "";
        }
        const month = params.value.getMonth() + 1;
        const day = params.value.getDate();
        return `${params.value.getFullYear()}-${month < 10 ? "0" + month : month}-${day < 10 ? "0" + day : day}`;
      },
      cellEditorParams: {
        max: new Date("2008-12-31"),
      },
    },
    {
      field: "date",
      headerName: "Date as String (> 2008)",
      cellEditor: "agDateStringCellEditor",
      cellEditorParams: {
        min: "2008-12-31",
      },
    },
  ];
  defaultColDef: ColDef = {
    editable: true,
    cellDataType: false,
  };
  rowData!: IModifiedOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IModifiedOlympicData>) {
    this.http
      .get<
        IModifiedOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe(
        (data) =>
          (this.rowData = data.map((rec: IOlympicData) => ({
            ...rec,
            date: dateToIso(rec.date),
            dateObj: stringToDate(rec.date),
          }))),
      );
  }
}

const stringToDate = (date: string): Date | null => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return null;
  }
  return new Date(Number(year), Number(month) - 1, Number(day));
};
const dateToIso = (date: string | null): string => {
  const [day, month, year] = (date || "").split("/");
  if (day == null || month == null || year == null) {
    return "";
  }
  return `${year}-${month}-${day}`;
};
```

[Live example: Cell Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation/angular/)

## Overriding Validation

To customise validation in a Provided Editor, use the `getValidationErrors()` callback inside `ICellEditorParams`. The callback receives the editor's `internalErrors`, and its return value replaces the Provided Editor's validation result. Include `internalErrors` in the returned array if the built-in constraints should still apply alongside your custom rules.

Properties available on the `ICellEditorParams&lt;TData = any, TValue = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationErrors` | `Function` |  |  |  |

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'athlete',
        cellEditorParams: {
            getValidationErrors: (params) => {
                const { value, internalErrors } = params;
                const errors = [...(internalErrors ?? [])];
                if (!value || value.length < 3) {
                    errors.push('The value has to be at least 3 characters long.');
                }

                return errors.length ? errors : null;
            },
        },
    },
];
```

If the callback returns errors, the Grid will show the errors in a tooltip when hovering the editor and discard the edit value before completing (depending on the [Validation Modes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-validation/#validation-modes)).

This is demonstrated in the following example, note that:

- `Athlete` has to be at least `3` characters.
- `Age` has to be different than `18`.

#### Cell Editor Validation Override

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  IErrorValidationParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      cellEditorParams: {
        getValidationErrors: (params: IErrorValidationParams) => {
          const { value } = params;
          if (!value || value.length < 3) {
            return ["The value has to be at least 3 characters long."];
          }
          return null;
        },
      },
    },
    {
      field: "age",
      cellEditorParams: {
        getValidationErrors: (params: IErrorValidationParams) => {
          const { value } = params;
          if (value != null && value == 18) {
            return ["Value has to be different than 18"];
          }
          return null;
        },
      },
    },
  ];
  defaultColDef: ColDef = {
    editable: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Editor Validation Override](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-override/angular/)

## Validation Modes

The Grid supports two modes for handling invalid edits, configured via the grid option `invalidEditValueMode`:

| Mode | Description |
| --- | --- |
| `'revert'` (default) | Cancels the edit and reverts the cell to its original value if the value is invalid. |
| `'block'` | Keeps the invalid editing session open until a valid value is provided or the edit is cancelled. Full Row Editing still allows navigation between editors in the same row. |

Use the `'block'` mode when you want to strictly enforce valid input before allowing the user to proceed.

```ts
<ag-grid-angular
    [invalidEditValueMode]="invalidEditValueMode"
    /* other grid options ... */ />

this.invalidEditValueMode = 'block';
```

#### Cell Editor Validation Modes

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  EditValidationCommitType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <label>
        <span>Cell Editor Validation Mode: </span>
        <select id="select-validation-mode" (change)="onValidationModeSelect()">
          <option value="revert">revert</option>
          <option value="block">block</option>
        </select>
      </label>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [invalidEditValueMode]="invalidEditValueMode"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    {
      field: "athlete",
      headerName: "Athlete (maxLength 10)",
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        maxLength: 10,
      },
    },
    {
      field: "age",
      headerName: "Age (>= 0 and <=100)",
      cellEditor: "agNumberCellEditor",
      cellEditorParams: {
        min: 0,
        max: 100,
      },
    },
  ];
  defaultColDef: ColDef = {
    editable: true,
  };
  invalidEditValueMode: EditValidationCommitType = "revert";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onValidationModeSelect() {
    const value: "revert" | "block" = document.querySelector<HTMLSelectElement>(
      "#select-validation-mode",
    )?.value as EditValidationCommitType;
    this.gridApi.setGridOption("invalidEditValueMode", value);
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Editor Validation Modes](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/cell-editor-validation-modes/angular/)

## Full Row Editing Validation

When using [Full Row Editing](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-full-row/), the Grid will validate each cell editor in the row individually, using the same mechanisms described in the previous sections.

In addition, the Grid can also perform cross-field validation by using the optional callback `getFullRowEditValidationErrors(params)`. This allows you to implement logic that checks relationships between fields — for example, ensuring that one field is greater than another.

This callback should return an array of non-empty, user-facing error strings if the row is in an invalid state. If no errors are found, it should return `null`.

The row data is not updated until the edit is committed. Use `editorsState` to validate the proposed row values; each entry contains the column ID together with its old and new values.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFullRowEditValidationErrors` | `GetFullRowEditValidationErrors` |  |  |  |

```ts
<ag-grid-angular
    [getFullRowEditValidationErrors]="getFullRowEditValidationErrors"
    /* other grid options ... */ />

this.getFullRowEditValidationErrors = ({ editorsState }) => {
    const values = Object.fromEntries(
        editorsState.map(({ colId, newValue }) => [colId, newValue]),
    );
    const min = Number(values.min);
    const max = Number(values.max);

    if (min > max) {
        return ['Min cannot be greater than Max'];
    }
    return null;
};
```

A row edit will only complete successfully if **both** the individual cell editors **and** the full-row validation return no errors.

### Accessibility

When a cell or full-row validation error is added, or its wording changes, the Grid announces the relevant error details to screen reader users. Revalidating unchanged errors, for example when navigating between editors in the same row, does not repeat the announcement.

If `invalidEditValueMode` is set to `'block'` and prevents the user from completing a full-row edit, the Grid announces a summary of the current errors even if they were announced previously. Cell editor errors are identified by their column name. Errors returned by `getFullRowEditValidationErrors` apply to the row as a whole, so each error message should identify the fields or condition that the user needs to correct.

The full-row announcement text can be customised through the `ariaFullRowValidationError` and `ariaFullRowEditValidationFailed` [localisation keys](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/localisation/). In a blocked-completion summary, `ariaRowIndex` identifies errors that belong to another edited row and distinguishes errors from multiple rows.

This is demonstrated in the following example. Note the following validation rules:

- `Weight` has to be between `0` and `500`, inclusive.
- `Height` has to be between `0` and `300`, inclusive.
- **Full Row Edit Validation** ensures that the Body Mass Index (BMI), calculated using height and weight, is between `10` and `80`.

#### Full Row Editing Validation

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  EditStrategyType,
  EditValidationCommitType,
  GetFullRowEditValidationErrors,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  SelectEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SelectEditorModule,
  TextEditorModule,
  NumberEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [editType]="editType"
    [rowData]="rowData"
    [invalidEditValueMode]="invalidEditValueMode"
    [getFullRowEditValidationErrors]="getFullRowEditValidationErrors"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "name",
    },
    {
      field: "weight",
      headerName: "Weight (kg)",
      cellDataType: "number",
      cellEditorParams: {
        min: 0,
        max: 500,
      },
    },
    {
      field: "height",
      headerName: "Height (cm)",
      cellDataType: "number",
      cellEditorParams: {
        min: 0,
        max: 300,
      },
    },
    {
      headerName: "BMI",
      cellDataType: "number",
      valueGetter: (params) => {
        const { weight, height } = params.data ?? {};
        if (!weight || !height) return null;
        const heightM = height / 100;
        return weight / (heightM * heightM);
      },
      valueFormatter: (params) => params.value?.toFixed(2),
      editable: false,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    editable: true,
    cellDataType: false,
  };
  editType: EditStrategyType = "fullRow";
  rowData: any[] | null = getRowData();
  invalidEditValueMode: EditValidationCommitType = "block";
  getFullRowEditValidationErrors: GetFullRowEditValidationErrors = ({
    editorsState,
  }) => {
    const values = Object.fromEntries(
      editorsState.map(({ colId, newValue }) => [colId, newValue]),
    );
    const weight = parseFloat(values["weight"]);
    const height = parseFloat(values["height"]);
    const heightM = height / 100;
    const bmi = weight / (heightM * heightM);
    const errors: string[] = [];
    if (!Number.isFinite(bmi)) {
      errors.push(
        "BMI cannot be calculated. Enter valid Weight and Height values.",
      );
    } else if (bmi < 10 || bmi > 80) {
      errors.push(
        `BMI is ${bmi.toFixed(2)}. It must be between 10 and 80. Check Weight and Height.`,
      );
    }
    return errors.length ? errors : null;
  };
}

function getRowData() {
  const rowData = [
    { name: "Alice", weight: 68, height: 165 },
    { name: "Bob", weight: 85, height: 178 },
    { name: "Charlie", weight: 72, height: 172 },
    { name: "Diana", weight: 54, height: 160 },
    { name: "Ethan", weight: 90, height: 182 },
    { name: "Fiona", weight: 63, height: 168 },
    { name: "George", weight: 77, height: 175 },
    { name: "Hannah", weight: 59, height: 162 },
    { name: "Ian", weight: 95, height: 185 },
    { name: "Julia", weight: 70, height: 170 },
  ];
  return rowData;
}
```

[Live example: Full Row Editing Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/full-row-editing-validation/angular/)

## Validation of Custom Editors

Custom Cell Editors can participate in the Grid's validation system by optionally implementing the following methods:

Properties available on the `ICellEditor&lt;TValue = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getValidationElement` | `Function` |  |  |  |
| `getValidationErrors` | `Function` |  |  |  |

These methods are called automatically before the Grid attempts to complete the edit. You can also manually trigger validation by calling the validate() method available in the cellEditorParams, for example:

```
cellEditorParams.validate();
```

This is useful if you want to validate input during editing, such as in response to an onInput event in the Custom Phone Editor.

#### Component Editor Validation

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RichSelectModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RichSelectModule,
  NumberEditorModule,
  TextEditorModule,
  CustomEditorModule,
]);
import { PhoneEditor } from "./phone-editor.component";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, PhoneEditor],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [defaultColDef]="defaultColDef"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "name" },
    {
      field: "phone",
      headerName: "Custom Phone Editor",
      cellEditor: PhoneEditor,
    },
  ];
  rowData: any[] | null = getData();
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
}
```

[Live example: Component Editor Validation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-validation/component-editor-validation/angular/)
